#version 330 core

float pi = 3.14159;
vec3 hsvToRgb(vec3 hsl) {
	while (hsl.x > 1) {
		hsl.x -= 1;
	}
	int hi = int(floor(hsl.x * 6));
	float f = hsl.x * 6 - hi;

	float p = hsl.z * (1 - hsl.y);
	float q = hsl.z * (1 - hsl.y * f);
	float t = hsl.z * (1 - hsl.y * (1 - f));

	switch (hi) {
		case 0: return vec3(hsl.z, t, p);
		case 1: return vec3(q, hsl.z, p);
		case 2: return vec3(p, hsl.z, t);
		case 3: return vec3(p, q, hsl.z);
		case 4: return vec3(t, p, hsl.z);
		case 5: return vec3(hsl.z, p, q);
		default: return vec3(0);
	}
}

in float fragValue;
flat in int pattern;
void main() {
	vec4 fragColor1 = vec4(1.0, 0.0, 0.0, 1.0);
	vec4 fragColor2 = vec4(0.0, 1.0, 0.0, 1.0);
	switch (pattern) {
	case 0:
		gl_FragColor = vec4(hsvToRgb(vec3(fragValue, 1, 1)), 1);
		break;

	case 1:
		gl_FragColor = vec4(hsvToRgb(vec3(0, fragValue, 1)), 1);
		break;

	case 2:
		gl_FragColor = vec4(hsvToRgb(vec3(0, 1, fragValue)), 1);
		break;

	case 3:
		gl_FragColor = mix(fragColor1, fragColor2, sin(fragValue * 4 * 3.14159) * 0.5 + 0.5);
		break;

	case 4:
		gl_FragColor = mix(fragColor1, fragColor2, step(0.5, sin(fragValue * 4 * 3.14159) * 0.5 + 0.5));
		break;

	default:
		gl_FragColor = vec4(0.0);
	}
}